﻿using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using IgHierarchicalGrid_Model.Models;
using Infragistics.Web.Mvc;

namespace IgHierarchicalGrid_Model.Controllers
{
    public class HomeController : Controller
    {
        //
        // GET: /Home/

        public ActionResult Index()
        {
            //This object will serve as the basis for binding to data
            //on the Index.cshtml View with the MVC Helpers. See:
            //@model = OctaneUIWebApplication5.Models.CustomersViewModel
            var viewModel = new CustomersViewModel
            {
                //IEnumerable of Customer Objects
                Customers = GetCustomers(),

                //IEnumerable of CustomerCountSummary Objects
                //For use with binding to the Chart
              //  CustomerCountSummaries = GetCustomerCounts()
            };

            return View(viewModel);
        }

        //This method aggregates the Customer data into a format that is easily
        //consumed by the Chart
        private IEnumerable<CustomerCountSummary> GetCustomerCounts()
        {
            var customers = GetCustomers();
            var active = from c in customers
                         where c.IsActive
                         select c;

            var inActive = from c in customers
                           where (c.IsActive == false)
                           select c;

            return new List<CustomerCountSummary> { 
                new CustomerCountSummary { CategoryLabel = "Active", CustomerCount = active.Count() },
                new CustomerCountSummary { CategoryLabel = "Inactive", CustomerCount = inActive.Count() }
            };
        }
        [ActionName("save")]
        public ActionResult save()
        {
            //int iTipoDeErro = -1;
           
            GridModel m = new GridModel();

            JsonResult result = new JsonResult();
            Dictionary<string, int> response = new Dictionary<string, int>();
            List<Customer> ListCustomer = new List<Customer>();

            //ViewData["GenerateCompactJSONResponse"] = false;
            List<Transaction<Customer>> categoryTransactions = m.LoadTransactions<Customer>(HttpContext.Request.Form["ig_transactions"]);
            foreach (Transaction<Customer> t in categoryTransactions)
            {
               
            }
            List<Transaction<Product>> productTransactions = m.LoadTransactions<Product>(HttpContext.Request.Form["ig_transactions"]);
            foreach (Transaction<Product> t in productTransactions)
            {
               
            }

            result.Data = response;
            return result;
       
    }
        private IEnumerable<Customer> GetCustomers()
        {
            return new List<Customer>
            {
                new Customer { ID=1, Name="John Smith", IsActive=true, Products=new List<Product>(){ new Product(){ ID=1,Name="product 1", CustomerID=1} } },
                new Customer { ID=2, Name="Bob Richards", IsActive=false, Products=new List<Product>(){ new Product(){ ID=2,Name="product 2", CustomerID=2} } },
                new Customer { ID=3, Name="Marge Wright", IsActive=false, Products=new List<Product>(){ new Product(){ ID=3,Name="product 3", CustomerID=3}, new Product(){ ID=4,Name="product 4", CustomerID=3} }},
                new Customer { ID=4, Name="Dwight Long", IsActive=true },
                new Customer { ID=5, Name="Amy Grant", IsActive=true },
            };
        }

    }
}
